# Class ScriptExt

java.lang.Object
org.jmol.scriptext.ScriptExt

Direct Known Subclasses:
  `CmdExt, IsoExt`

public abstract class ScriptExt extends Object

## Field Summary

Fields
Modifier and Type
Field
Description
`protected boolean`
`chk`
`protected ScriptEval`
`e`
`protected int`
`slen`
`protected T[]`
`st`
`protected Viewer`
`vwr`

## Constructor Summary

Constructors
Constructor
Description
`ScriptExt()`

## Method Summary

Modifier and Type
Method
Description
`protected BS`
`atomExpressionAt(int i)`
`protected P3[]`
`bsToArray(BS bs)`
`protected P3`
`centerParameter(int i)`
`protected void`
`checkLength(int i)`
`abstract String`
`dispatch(int iTok, boolean b, T[] st)`
`protected void`
`error(int err)`
`protected void`
`finalizeObject(int shapeID, int colorArgb, float translucentLevel, int intScale, boolean doSet, Object data, int iptDisplayProperty, BS bs)`
`protected float`
`floatParameter(int i)`
`protected P3[]`
`getAllPoints(int index, int nmin)`
`protected float`
`getColorTrans(ScriptEval eval, int i, boolean allowNone, int[] ret)`
Checks color, translucent, opaque parameters.
`protected int[][]`
`getIntArray2(int i)`
`protected P3`
`getPoint3f(int i, boolean allowFractional)`
`protected Object`
`getShapeProperty(int shapeType, String propertyName)`
`protected T`
`getToken(int i)`
`ScriptExt`
`init(Object eval)`
`protected int`
`intParameter(int index)`
`protected void`
`invArg()`
`protected void`
`invPO()`
`protected boolean`
`isFloatParameter(int index)`
`protected String`
`paramAsStr(int i)`
`protected String`
`setShapeId(int iShape, int i, boolean idSeen)`
`protected void`
`setShapeProperty(int shapeType, String propertyName, Object propertyValue)`
`protected void`
`showString(String s)`
`protected String`
`stringParameter(int index)`
`protected int`
`tokAt(int i)`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### vwr

protected Viewer vwr

### e

protected ScriptEval e

### chk

protected boolean chk

### st

protected T[] st

### slen

protected int slen

## Constructor Details

### ScriptExt

public ScriptExt()

## Method Details

### init

public ScriptExt init(Object eval)

### dispatch

public abstract String dispatch(int iTok, boolean b, T[] st) throws ScriptException

Throws:
  `ScriptException`

### atomExpressionAt

protected BS atomExpressionAt(int i) throws ScriptException

Throws:
  `ScriptException`

### checkLength

protected void checkLength(int i) throws ScriptException

Throws:
  `ScriptException`

### error

protected void error(int err) throws ScriptException

Throws:
  `ScriptException`

### invArg

protected void invArg() throws ScriptException

Throws:
  `ScriptException`

### invPO

protected void invPO() throws ScriptException

Throws:
  `ScriptException`

### getShapeProperty

protected Object getShapeProperty(int shapeType, String propertyName)

### paramAsStr

protected String paramAsStr(int i) throws ScriptException

Throws:
  `ScriptException`

### centerParameter

protected P3 centerParameter(int i) throws ScriptException

Throws:
  `ScriptException`

### floatParameter

protected float floatParameter(int i) throws ScriptException

Throws:
  `ScriptException`

### getPoint3f

protected P3 getPoint3f(int i, boolean allowFractional) throws ScriptException

Throws:
  `ScriptException`

### intParameter

protected int intParameter(int index) throws ScriptException

Throws:
  `ScriptException`

### isFloatParameter

protected boolean isFloatParameter(int index)

### setShapeProperty

protected void setShapeProperty(int shapeType, String propertyName, Object propertyValue)

### showString

protected void showString(String s)

### stringParameter

protected String stringParameter(int index) throws ScriptException

Throws:
  `ScriptException`

### getToken

protected T getToken(int i) throws ScriptException

Throws:
  `ScriptException`

### tokAt

protected int tokAt(int i)

### setShapeId

protected String setShapeId(int iShape, int i, boolean idSeen) throws ScriptException

Throws:
  `ScriptException`

### getColorTrans

protected float getColorTrans(ScriptEval eval, int i, boolean allowNone, int[] ret) throws ScriptException
Checks color, translucent, opaque parameters.

Parameters:
  `eval` -
  `i` -
  `allowNone` -
  `ret` - returned int argb color
Returns:
  translucentLevel and sets iToken and ret[0]
Throws:
  `ScriptException`

### finalizeObject

protected void finalizeObject(int shapeID, int colorArgb, float translucentLevel, int intScale, boolean doSet, Object data, int iptDisplayProperty, BS bs) throws ScriptException

Parameters:
  `shapeID` -
  `colorArgb` -
  `translucentLevel` -
  `intScale` -
  `doSet` -
  `data` -
  `iptDisplayProperty` - pointer to mesh nofill....; if default is meshNoFill, then this number is -1 - ipt
  `bs` -
Throws:
  `ScriptException`

### getIntArray2

protected int[][] getIntArray2(int i) throws ScriptException

Throws:
  `ScriptException`

### getAllPoints

protected P3[] getAllPoints(int index, int nmin) throws ScriptException

Throws:
  `ScriptException`

### bsToArray

protected P3[] bsToArray(BS bs)